<%@ taglib uri="http://jakarta.apache.org/struts/tags-bean" prefix="bean" %>
<%@page import="de.intevation.gnv.action.sessionmodel.SessionModelFactory"%>
<%@page import="de.intevation.gnv.action.sessionmodel.SessionModel"%>
<%@page import="de.intevation.gnv.action.sessionmodel.DiagrammOptions"%>
<%@page import="de.intevation.gnv.artifactdatabase.objects.OutputParameter"%>
<%@page import="de.intevation.gnv.artifactdatabase.objects.ArtifactObject"%>
<%@page import="java.util.Collection"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.net.URLEncoder"%>
<%
    SessionModel sm         = SessionModelFactory.getInstance().getSessionModel(request);
    ArtifactObject artifact = sm.getCurrentArtifact();
    String mimeType         = null;
    String wmslayer         = null;
    String parameterString  = "";

    String target    = "chart";
    String targetCSV = "csv";
    String targetODV = "odv";
    String targetZIP = "zip";
    String targetWMS = "wms";
    String targetSta = "statistics";
    String targetHis = "histogram";

    boolean supportChart = sm.getOutputMode(target)    != null;
    boolean supportCSV   = sm.getOutputMode(targetCSV) != null;
    boolean supportODV   = sm.getOutputMode(targetODV) != null;
    boolean supportZIP   = sm.getOutputMode(targetZIP) != null;
    boolean supportWMS   = sm.getOutputMode(targetWMS) != null;
    boolean supportSta   = sm.getOutputMode(targetSta) != null;
    boolean supportHis   = sm.getOutputMode(targetHis) != null;

    if (supportChart){
        mimeType = sm.getOutputMode(target).getMimeType();
        DiagrammOptions diagrammOptions = sm.getDiagrammOptions();
        Collection<OutputParameter> op  = sm.getOutputMode(target).getOutputParameters();

       if (op != null){
           Iterator<OutputParameter> it = op.iterator();
           while (it.hasNext()){
               OutputParameter parameter = it.next(); 
               parameterString = parameterString +"&amp;"+parameter.getName()+"="+(diagrammOptions != null ? diagrammOptions.getValue(parameter.getName()): parameter.getValue());
           }
       }
    }

    String mimeTypeCSV = null;
    if (supportCSV){
        mimeTypeCSV = sm.getOutputMode(targetCSV).getMimeType();
    }

    String mimeTypeODV = null;
    if (supportODV){
        mimeTypeODV = sm.getOutputMode(targetODV).getMimeType();
    }

    String mimeTypeZIP = null;
    if (supportZIP) {
        mimeTypeZIP = sm.getOutputMode(targetZIP).getMimeType();
    }

    String mimeTypeWMS = null;
    if (supportWMS) {
        mimeTypeWMS = sm.getOutputMode(targetWMS).getMimeType();
        wmslayer    = artifact.getId();
    }
%>

<%-- display export options if one is supported in this state --%>
<% if (supportChart || supportCSV || supportODV || supportWMS || supportZIP) { %>
    <div id="export">
        <fieldset>
            <legend><bean:message key="gnviewer.export.fieldset.title"/></legend>
            <%if (supportChart) { %>
            <a href="<%=response.encodeURL("chart.do?mimetype="+mimeType+"&amp;target="+target+"&amp;mode=img"+parameterString+"&amp;uid="+System.currentTimeMillis())%>" title="<bean:message key="gnviewer.output.options.save.title"/>">
                <img src="images/chart_curve.png" border="0"/>
            </a>
            <%}%>
            <%if (supportWMS) { %>
            <a href="<%=response.encodeURL("wms.do?mimetype="+mimeTypeWMS+"&amp;target="+targetWMS+"&amp;uid="+System.currentTimeMillis()+"&amp;layer="+wmslayer)%>" title="<bean:message key="gnviewer.output.options.export.wms.title"/>">
                <img src="images/map_go.png" border="0"/>
            </a>
            <%}%>
            <%if (supportZIP) { %>
            <a href="<%=response.encodeURL("export.do?mimetype="+mimeTypeZIP+"&amp;target="+targetZIP+"&amp;uid="+System.currentTimeMillis())%>" title="<bean:message key="gnviewer.output.options.export.zip.title"/>">
                <img src="images/disk.png" border="0"/>
            </a>
            <%}%>

            <%if (supportSta) { %>
                <a href="<%=response.encodeURL("statistic.do")%>" title="<bean:message key="gnviewer.statistic.button"/>">
                    <img src="images/statistics.png" border="0"/>
                </a>
            <%}%>

            <%if (supportHis) { %>
                <a href="<%=response.encodeURL("histogram.do")%>" title="<bean:message key="gnviewer.histogram.button"/>">
                    <img src="images/chart_bar.png" border="0"/>
                </a>
            <%}%> 
            <%if (supportCSV) { %>
            <a href="<%=response.encodeURL("export.do?mimetype="+mimeTypeCSV+"&amp;target="+targetCSV+"&amp;uid="+System.currentTimeMillis())%>" title="<bean:message key="gnviewer.output.options.export.csv.title"/>">
                <img src="images/data_export.png" border="0"/>
            </a>
            <%}%>
            <%if (supportODV) { %>
            <a href="<%=response.encodeURL("export.do?mimetype="+mimeTypeODV+"&amp;target="+targetODV+"&amp;uid="+System.currentTimeMillis())%>" title="<bean:message key="gnviewer.output.options.export.odv.title"/>">
                <img src="images/data_export.png" border="0"/>
            </a> 
            <%}%>
        </fieldset>
    </div>
<%}%>
